<?php
/**
 * File handler
 * @package    Albireo I
 * @subpackage Core
 * @copyright  Copyright (c) 2009 Albireo Solutions. All rights reserved
 * @license    GNU/AGPL http://www.gnu.org/licenses/agpl.html
 *
 * Albireo is free software! You can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *	GNU Affero General Public License for more details.
 */
class FileHandler {

    /**
     * validates file name form
     * @param String $file_name original file name
     * @return String validated file name
     */
    public static function validateFileName ( $file_name ) {
        $bad_chars = array ( " ", "<", ">", "$", "^", "#", "@", "*", "\\", "(", ")", "%", "&", "?", ";", ",", "\'", "`", "\"", "á", "Á", "ä", "Ä", "č", "Č", "ď", "Ď", "é", "É", "ě", "ë", "Ě", "Ë", "í", "ï", "Í", "ĺ", "Ĺ", "ľ", "Ľ", "ň", "Ň", "ó", "Ó", "ö", "Ö", "ô", "ŕ", "Ŕ", "ř", "Ř", "š", "Š", "ť", "Ť", "ú", "Ú", "ů", "ü", "Ů", "ý", "Ý", "ž", "Ž" );
        $asci_chars = array ( "-", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "a", "A", "a", "A", "c", "C", "d", "D", "e", "E", "e", "e", "E", "E", "i", "I", "i", "l", "L", "l", "L", "n", "N", "o", "O", "o", "o", "O", "r", "R", "r", "R", "s", "S", "t", "T", "u", "U", "u", "u", "U", "y", "Y", "z", "Z" );
        $file = str_replace ( $bad_chars, $asci_chars, trim ( $file_name ) );
        return urlencode ( $file );
    }

}
?>