<?php
/**
 * This class is used for localization and contains settings for locale
 * and gettext. Works with design pattern Singleton.
 * Gettext is called in the source code by _() function.
 * @package    Albireo I
 * @subpackage Core
 * @copyright  Copyright (c) 2009 Albireo Solutions. All rights reserved
 * @license    GNU/AGPL http://www.gnu.org/licenses/agpl.html
 *
 * Albireo is free software! You can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *	GNU Affero General Public License for more details.
 */
class Localization {

    private static $instance;
    private $lang = "cs";

    /**
     * Singleton method for calling Localization instance
     * @return object
     */
    public static function session ()
    {
    
    	if ( self::$instance == null ) {
    	    self::$instance = new Localization ();
    	}
    	return self::$instance;
    	
    } // end connection

    private function __construct ()
    {
        mb_internal_encoding ( "UTF-8" );
	@date_default_timezone_set ( "Europe/Prague" );
	@putenv ( "LANG=". $this -> lang );
	@setlocale ( LC_ALL, $this -> lang );
	@bindtextdomain ( "languages", realpath ( "locale" ) );
	@textdomain ( "languages" );
	
    } // end __construct

    private function __clone ()
    {
    } // end __clone

    /**
     * current language
     * @return char(2)
     */
    public function getLanguage ()
    {
    	return $this -> lang;
    } // end getLanguage

    /**
     * gets first file address associated to a php script
     * @param String $file php script file name (without .php extension)
     * @param boolean $extension enables or disables file extension
     * @return String
     */
    public function getFile ( $file, $extension = true )
    {
    	return Database::connection () -> getResult ( "SELECT `file` FROM `header` WHERE `id`=(SELECT `id_header` FROM `scriptpages` WHERE `script`='$file') AND `lang`='". Localization::session () -> getLanguage () ."' LIMIT 1;" ). ( ( $extension ) ? Tools::baseSettings () -> getSetting ( "file_extension" ) : "" );
    } // end getFile

} 
 
?>