<?php
/**
 * This is interface for working with classes managing Albireo users
 * @package    Albireo I
 * @subpackage Core
 * @copyright  Copyright (c) 2009 Albireo Solutions. All rights reserved
 * @license    GNU/AGPL http://www.gnu.org/licenses/agpl.html
 *
 * Albireo is free software! You can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *	GNU Affero General Public License for more details.
 */
interface UserInterface {

    /**
     * gets name of the class
     * @return String
     */
    public function getType ();

    /**
     * gets users nick
     * @return String
     */
    public function getNick ();

    /**
     * gets users full name
     * @return String
     */
    public function getFullName ();

    /**
     * gets users id in database table users
     * @return number
     */
    public function getId ();

    /**
     * gets users e-mail
     * @return String
     */
    public function getEmail ();

    /**
     * gets primary group id in database table usergroups
     * @return number 1-4
     * 1: administrators
     * 2: webmasters
     * 3: editors
     * 4: users
     */
    public function getPrimaryGroup ();

    /**
     * gets users prefered language
     * @return char(2)
     */
    public function getLanguage ();

}

?>